var jobs = require('./jobs');

module.exports = function(config, onDone) {
  jobs.registerMultiple(
    config,
    /*['input-hugo', './input-hugo'],
    ['output-console', './output-console'],
    ['output-filesystem', './output-filesystem'],
    ['transformer-basichtml', './transformer-basichtml'],
    ['transformer-git', './transformer-git'],
    ['transformer-markdown', './transformer-markdown'],
    ['transformer-nunjucks', './transformer-nunjucks'],
    ['transformer-tags', './transformer-tags'],
    ['transformer-urlizetags', './transformer-urlizetags'],*/
    ['transformer-other', './transformer-other']
    //['transformer-images', './transformer-images']
  )
  .then(function() {
    if(onDone) onDone(jobs);
  })
  .catch(function(e) {
    console.log(e.stack)
    jobs.close();
  });
}
